$context.setFinished(true)
<%
// Groovy script for xwiki which compresses all the TinyMCE javascript
// files into a single gzipped stream.
//
// Used tiny_mce_gzip.php as a guide in writing this.
//
// Usage:  Save this file as an XWikiDocument named "tiny_mce_gzip" (any
// space is fine) and replace the <script.../> reference in your client documen
// with the path to the xwiki document you just created.  You may also need to
// set the tinymcePath variable below depending on how you include tinymce in
// xwiki
//
// Author: Matthew Conway <wr0ngway@yahoo.com>
// Date: 2005-09-15

import java.util.zip.GZIPOutputStream;
import java.util.Calendar;

suffix = ""; // Set to "_src" to use source version
expiresOffset = 10; // 10 days util client cache expires

// relative to xwiki context
tinymcePath = "/tinymce/jscripts/tiny_mce";
mceUrl = request.getContextPath() + tinymcePath;

response.setHeader("Content-Encoding", "gzip");
response.setHeader("Content-type", "text/plain; charset: UTF-8");
response.setHeader("Cache-Control", "must-revalidate");
expirationDate = Calendar.getInstance();
expirationDate.add(Calendar.DATE, expiresOffset);
response.setDateHeader("Expires",  expirationDate.getTimeInMillis());

gzOs = new PrintStream(new GZIPOutputStream(response.getOutputStream()));

// Get data to load
theme = request.getParameter("theme");
language = request.getParameter("language");
plugins = request.getParameter("plugins");

def writeFile(path)
{
    is = context.getContext().getEngineContext().getResourceAsStream(path);
    if (is != null)
    {
        byte[] buf = new byte[4096];
        while ((c = is.read(buf)) > 0)
        {
            gzOs.write(buf, 0, c);
        }
        is.close();
    }
}

if (theme != null)
{
    // Write main script and patch some things
    writeFile(tinymcePath + "/tiny_mce" + suffix + ".js");
    gzOs.print "TinyMCE.prototype.loadScript = function() {};";

    // Patches needed for xwiki becauuse groovy script lives at a different
    // path than tinymce.  Note that if you have a relative url
    // for popups_css or content_css in your tinymce settings, you'll
    // need to make it absolute
    gzOs.print "tinyMCE.baseURL = '${mceUrl}';";
    gzOs.print "tinyMCE.srcMode = '${suffix}';";
    gzOs.print "tinyMCE.init(TinyMCECompressed_settings);";
    gzOs.print "tinyMCE.documentBasePath = '${mceUrl}';";
    gzOs.print "tinyMCE.documentBaseURL = '${mceUrl}';";
    gzOs.print "tinyMCE.defParam('document_base_url', '${mceUrl}');";

    // Load theme, language pack and theme language packs
    writeFile(tinymcePath + "/themes/" + theme + "/editor_template" + suffix + ".js");
    writeFile(tinymcePath + "/themes/" + theme + "/langs/" + language + ".js");
    writeFile(tinymcePath + "/langs/" + language + ".js");

    // Load all plugins and their language packs
    plugins = plugins.split(",");
    plugins.each {
        writeFile(tinymcePath + "/plugins/" + it + "/editor_plugin" + suffix + ".js");
        writeFile(tinymcePath + "/plugins/" + it + "/langs/" + language + ".js");
    }
}
else
{
    gzOs.print """

var TinyMCECompressed_settings = null;

function TinyMCECompressed() {
}

TinyMCECompressed.prototype.init = function(settings) {
	var elements = document.getElementsByTagName('script');
	var scriptURL = "";

	for (var i=0; i<elements.length; i++) {
		if (elements[i].src && elements[i].src.indexOf("tiny_mce_gzip") != -1) {
			scriptURL = elements[i].src;
			break;
		}
	}

	settings["theme"] = typeof(settings["theme"]) != "undefined" ? settings["theme"] : "default";
	settings["plugins"] = typeof(settings["plugins"]) != "undefined" ? settings["plugins"] : "";
	settings["language"] = typeof(settings["language"]) != "undefined" ? settings["language"] : "en";
	settings["button_tile_map"] = typeof(settings["button_tile_map"]) != "undefined" ? settings["button_tile_map"] : true;

	scriptURL += "?theme=" + escape(settings["theme"]) + "&language=" + escape(settings["language"]) + "&plugins=" + escape(settings["plugins"]);
	document.write('<sc'+'ript language="javascript" type="text/javascript" src="' + scriptURL + '"></script>');

	TinyMCECompressed_settings = settings;
}

var tinyMCE = new TinyMCECompressed();

"""

}

gzOs.close();

%>
